//
// PlacesAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PlacesAPI {
    /**
     Create new place

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func createPlace(body: PlaceCreate, completion: @escaping ((_ data: PlaceGet?,_ error: Error?) -> Void)) {
        createPlaceWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Create new place
     - POST /api/v1/places
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "camera_count" : 5,
  "updated_at" : "2000-01-23T04:56:07.000+00:00",
  "latitude" : 0.8008281904610115,
  "name" : "name",
  "description" : "description",
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "plan_count" : 5,
  "id" : 1,
  "longitude" : 6.027456183070403
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<PlaceGet> 
     */
    open class func createPlaceWithRequestBuilder(body: PlaceCreate) -> RequestBuilder<PlaceGet> {
        let path = "/api/v1/places"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlaceGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Delete place with provided ID

     - parameter placeId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func deletePlace(placeId: Int, completion: @escaping ((_ data: APIResponseStatusOK?,_ error: Error?) -> Void)) {
        deletePlaceWithRequestBuilder(placeId: placeId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Delete place with provided ID
     - DELETE /api/v1/places/{place_id}

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "status" : "ok"
}}]
     - parameter placeId: (path)  

     - returns: RequestBuilder<APIResponseStatusOK> 
     */
    open class func deletePlaceWithRequestBuilder(placeId: Int) -> RequestBuilder<APIResponseStatusOK> {
        var path = "/api/v1/places/{place_id}"
        let placeIdPreEscape = "\(placeId)"
        let placeIdPostEscape = placeIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{place_id}", with: placeIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<APIResponseStatusOK>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "DELETE", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get place with provided ID

     - parameter placeId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlace(placeId: Int, completion: @escaping ((_ data: PlaceGet?,_ error: Error?) -> Void)) {
        getPlaceWithRequestBuilder(placeId: placeId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get place with provided ID
     - GET /api/v1/places/{place_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "camera_count" : 5,
  "updated_at" : "2000-01-23T04:56:07.000+00:00",
  "latitude" : 0.8008281904610115,
  "name" : "name",
  "description" : "description",
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "plan_count" : 5,
  "id" : 1,
  "longitude" : 6.027456183070403
}}]
     - parameter placeId: (path)  

     - returns: RequestBuilder<PlaceGet> 
     */
    open class func getPlaceWithRequestBuilder(placeId: Int) -> RequestBuilder<PlaceGet> {
        var path = "/api/v1/places/{place_id}"
        let placeIdPreEscape = "\(placeId)"
        let placeIdPostEscape = placeIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{place_id}", with: placeIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlaceGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get place's cameras

     - parameter placeId: (path)  
     - parameter withoutPlans: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlaceCameras(placeId: Int, withoutPlans: Bool? = nil, completion: @escaping ((_ data: CameraList?,_ error: Error?) -> Void)) {
        getPlaceCamerasWithRequestBuilder(placeId: placeId, withoutPlans: withoutPlans).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get place's cameras
     - GET /api/v1/places/{place_id}/cameras
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "cameras" : [ {
    "onvif_host" : "onvif_host",
    "video_analytics" : { },
    "onvif_login" : "onvif_login",
    "video_streaming" : { },
    "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "latitude" : 0.8008281904610115,
    "origin" : {
      "place_name" : "place_name",
      "place_description" : "place_description",
      "place_longitude" : 2.027123023002322,
      "camera_position_x" : 5.637376656633329,
      "camera_position_y" : 2.3021358869347655,
      "plan_id" : 7,
      "plan_name" : "plan_name",
      "place_id" : 9,
      "place_latitude" : 3.616076749251911
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "video_storage" : { },
    "source" : { },
    "snapshot_url" : "http://example.com/aeiou",
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "ptz" : { },
    "name" : "name",
    "onvif_port" : 5,
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 1,
    "onvif_password" : "onvif_password",
    "plan_id" : 4,
    "longitude" : 6.027456183070403
  }, {
    "onvif_host" : "onvif_host",
    "video_analytics" : { },
    "onvif_login" : "onvif_login",
    "video_streaming" : { },
    "snapshot_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "latitude" : 0.8008281904610115,
    "origin" : {
      "place_name" : "place_name",
      "place_description" : "place_description",
      "place_longitude" : 2.027123023002322,
      "camera_position_x" : 5.637376656633329,
      "camera_position_y" : 2.3021358869347655,
      "plan_id" : 7,
      "plan_name" : "plan_name",
      "place_id" : 9,
      "place_latitude" : 3.616076749251911
    },
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "video_storage" : { },
    "source" : { },
    "snapshot_url" : "http://example.com/aeiou",
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "ptz" : { },
    "name" : "name",
    "onvif_port" : 5,
    "id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 1,
    "onvif_password" : "onvif_password",
    "plan_id" : 4,
    "longitude" : 6.027456183070403
  } ]
}}]
     - parameter placeId: (path)  
     - parameter withoutPlans: (query)  (optional, default to false)

     - returns: RequestBuilder<CameraList> 
     */
    open class func getPlaceCamerasWithRequestBuilder(placeId: Int, withoutPlans: Bool? = nil) -> RequestBuilder<CameraList> {
        var path = "/api/v1/places/{place_id}/cameras"
        let placeIdPreEscape = "\(placeId)"
        let placeIdPostEscape = placeIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{place_id}", with: placeIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "without_plans": withoutPlans
        ])


        let requestBuilder: RequestBuilder<CameraList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get place's list of plans

     - parameter placeId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlacePlans(placeId: Int, completion: @escaping ((_ data: PlanList?,_ error: Error?) -> Void)) {
        getPlacePlansWithRequestBuilder(placeId: placeId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get place's list of plans
     - GET /api/v1/places/{place_id}/plans
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "plans" : [ {
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "image_url" : "http://example.com/aeiou",
    "name" : "name",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : 6,
    "image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 0
  }, {
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "image_url" : "http://example.com/aeiou",
    "name" : "name",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "id" : 6,
    "image_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "place_id" : 0
  } ]
}}]
     - parameter placeId: (path)  

     - returns: RequestBuilder<PlanList> 
     */
    open class func getPlacePlansWithRequestBuilder(placeId: Int) -> RequestBuilder<PlanList> {
        var path = "/api/v1/places/{place_id}/plans"
        let placeIdPreEscape = "\(placeId)"
        let placeIdPostEscape = placeIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{place_id}", with: placeIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlanList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Get list of places

     - parameter latitude: (query)  (optional)
     - parameter longitude: (query)  (optional)
     - parameter radius: (query)  (optional)
     - parameter withoutGroups: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getPlaces(latitude: Decimal? = nil, longitude: Decimal? = nil, radius: Int? = nil, withoutGroups: Bool? = nil, completion: @escaping ((_ data: PlaceList?,_ error: Error?) -> Void)) {
        getPlacesWithRequestBuilder(latitude: latitude, longitude: longitude, radius: radius, withoutGroups: withoutGroups).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Get list of places
     - GET /api/v1/places
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "places" : [ {
    "camera_count" : 5,
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "latitude" : 0.8008281904610115,
    "name" : "name",
    "description" : "description",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "plan_count" : 5,
    "id" : 1,
    "longitude" : 6.027456183070403
  }, {
    "camera_count" : 5,
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "latitude" : 0.8008281904610115,
    "name" : "name",
    "description" : "description",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "plan_count" : 5,
    "id" : 1,
    "longitude" : 6.027456183070403
  } ]
}}]
     - parameter latitude: (query)  (optional)
     - parameter longitude: (query)  (optional)
     - parameter radius: (query)  (optional)
     - parameter withoutGroups: (query)  (optional, default to false)

     - returns: RequestBuilder<PlaceList> 
     */
    open class func getPlacesWithRequestBuilder(latitude: Decimal? = nil, longitude: Decimal? = nil, radius: Int? = nil, withoutGroups: Bool? = nil) -> RequestBuilder<PlaceList> {
        let path = "/api/v1/places"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "latitude": latitude, 
                        "longitude": longitude, 
                        "radius": radius?.encodeToJSON(), 
                        "without_groups": withoutGroups
        ])


        let requestBuilder: RequestBuilder<PlaceList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     Search places by provided query string

     - parameter body: (body)  
     - parameter withoutGroups: (query)  (optional, default to false)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func searchPlaces(body: PlaceSearchBody, withoutGroups: Bool? = nil, completion: @escaping ((_ data: PlaceList?,_ error: Error?) -> Void)) {
        searchPlacesWithRequestBuilder(body: body, withoutGroups: withoutGroups).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Search places by provided query string
     - POST /api/v1/places/search

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "places" : [ {
    "camera_count" : 5,
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "latitude" : 0.8008281904610115,
    "name" : "name",
    "description" : "description",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "plan_count" : 5,
    "id" : 1,
    "longitude" : 6.027456183070403
  }, {
    "camera_count" : 5,
    "updated_at" : "2000-01-23T04:56:07.000+00:00",
    "latitude" : 0.8008281904610115,
    "name" : "name",
    "description" : "description",
    "created_at" : "2000-01-23T04:56:07.000+00:00",
    "plan_count" : 5,
    "id" : 1,
    "longitude" : 6.027456183070403
  } ]
}}]
     - parameter body: (body)  
     - parameter withoutGroups: (query)  (optional, default to false)

     - returns: RequestBuilder<PlaceList> 
     */
    open class func searchPlacesWithRequestBuilder(body: PlaceSearchBody, withoutGroups: Bool? = nil) -> RequestBuilder<PlaceList> {
        let path = "/api/v1/places/search"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "without_groups": withoutGroups
        ])


        let requestBuilder: RequestBuilder<PlaceList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Update place with provided ID

     - parameter body: (body)  
     - parameter placeId: (path)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func updatePlace(body: PlaceUpdate, placeId: Int, completion: @escaping ((_ data: PlaceGet?,_ error: Error?) -> Void)) {
        updatePlaceWithRequestBuilder(body: body, placeId: placeId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Update place with provided ID
     - PUT /api/v1/places/{place_id}
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "camera_count" : 5,
  "updated_at" : "2000-01-23T04:56:07.000+00:00",
  "latitude" : 0.8008281904610115,
  "name" : "name",
  "description" : "description",
  "created_at" : "2000-01-23T04:56:07.000+00:00",
  "plan_count" : 5,
  "id" : 1,
  "longitude" : 6.027456183070403
}}]
     - parameter body: (body)  
     - parameter placeId: (path)  

     - returns: RequestBuilder<PlaceGet> 
     */
    open class func updatePlaceWithRequestBuilder(body: PlaceUpdate, placeId: Int) -> RequestBuilder<PlaceGet> {
        var path = "/api/v1/places/{place_id}"
        let placeIdPreEscape = "\(placeId)"
        let placeIdPostEscape = placeIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{place_id}", with: placeIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<PlaceGet>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
